lots of fixes
[distro-setup] / btrbk-run
old mode 100755 (executable)
new mode 100644 (file)
index 485c7f5..5e1a888
--- a/btrbk-run
+++ b/btrbk-run
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
+
+# todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
+
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+
 usage() {
-    echo "top of script file:"
-    sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
-    exit $1
+  cat <<'EOF'
+btrbk-run [OPTIONS]
+usually -t TARGET_HOST or -s SOURCE_HOST
+
+Note, at source location, intentionally not executable, run and read
+install-my-scripts.
+
+EOF
+  echo "top of script file:"
+  sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
+  exit $1
 }
 
-script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+# latest $MAIL_HOST
+if [[ -e /b/bash_unpublished/source-semi-priv ]]; then
+  source /b/bash_unpublished/source-semi-priv
+fi
+
+# note q is owned by root:1000
 
-# todo: finish figuring out fai / distro-setup
-# initial fstab / subvol setup.
+mountpoints=()
 
+rsync_mountpoint=/q
+
+# default options
 conf_only=false
 dry_run=false # mostly for testing
-resume_arg=
+rate_limit=no
+verbose=true; verbose_arg=-v
+progress_arg="--progress"
+pull_reexec=false
+
+default_args_file=/etc/btrbk-run.conf
+if [[ -s $default_args_file ]]; then
+  set -- $(< $default_args_file) "$@"
+  echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
+  cat $default_args_file
+  sleep 5
+fi
 
-temp=$(getopt -l help hcnrt: "$@") || usage 1
+orig_args=("$@")
+temp=$(getopt -l pull-reexec,help cl:m:nps:t:vh "$@") || usage 1
 eval set -- "$temp"
 while true; do
-    case $1 in
-        -c) conf_only=true; shift ;;
-        -n) dry_run=true; dry_run_arg=-n; shift ;;
-        # btrbk arg: Resume only. Skips snapshot creation.
-        -r) resume_arg=-r; shift ;;
-        -t) IFS=, targets=($2); shift 2 ;;
-        -h|--help) usage ;;
-        --) shift; break ;;
-        *) echo "$0: Internal error!" ; exit 1 ;;
-    esac
+  case $1 in
+    # only creates the config file, does not run btrbk
+    -c) conf_only=true; shift ;;
+    # bytes per second, suffix k m g
+    -l) rate_limit=$2; shift 2 ;;
+    # Comma separated mountpoints to backup. This has defaults set below.
+    -m) IFS=, mountpoints=($2); unset IFS; shift 2 ;;
+    -n) dry_run=true; dry_run_arg=-n; shift ;;
+    -p) progress_arg="--progress"; shift ;;
+    --pull-reexec) pull_reexec=true; shift ;;
+    -q) verbose=false; verbose_arg=; progress_arg=; shift ;;
+    # source host to receive a backup from
+    -s) source=$2; shift 2 ;;
+    # target hosts to send to. empty is valid for just doing local
+    # snapshot. we have default hosts we will populate.
+    -t) IFS=, targets=($2); unset IFS; shift 2 ;;
+    -v) verbose=true; verbose_arg=-v; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error!" ; exit 1 ;;
+  esac
 done
-read primary <<<"$@"
+
+# usefull commands are resume and archive
+cmd_arg=${1:-run}
+
+if [[ -v targets && $source ]]; then
+  echo "$0: error: -t and -s are mutually exclusive" >&2
+  exit 1
+fi
+
+# pull_reexec stops us from getting into an infinite loop if there is some
+# kind of weird problem
+if ! $pull_reexec && [[ $source ]]; then
+  tmpf=$(mktemp)
+  scp $source:/a/bin/distro-setup/btrbk-run $tmpf
+  if diff -q $tmpf $BASH_SOURCE; then
+    echo "$0: found newer version on host $source. reexecing"
+    install -T $tmpf /usr/local/bin/btrbk-run
+    /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
+  fi
+fi
+
+
+echo -e "$0: options: conf_only=$conf_only\ndry_run=$dry_run\nrate_limit=$rate_limit\nverbose=$verbose\ncmd_arg=$cmd_arg"
+### end options parsing
+
+
+# set default targets
+if [[ ! -v targets && ! $source ]]; then
+  case $HOSTNAME in
+    x2|kw)
+      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+        targets=($HOME_DOMAIN)
+      fi
+      ;;
+    tp)
+      targets=(frodo)
+      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+        if timeout -s 9 10 ssh x2 :; then
+          targets+=(x2)
+        fi
+      fi
+      ;;
+    frodo)
+      targets=()
+      ;;
+    *)
+      echo "$0: error: no default targets for this host, use -t"
+      exit 1
+      ;;
+  esac
+fi
+
+if [[ -v targets ]]; then
+  echo "targets: ${targets[*]}"
+fi
+
+if [[ $source ]]; then
+  echo "source: $source"
+fi
+
+
+if [[ $mountpoints ]]; then
+  for mp in ${mountpoints[@]}; do # default mountpoints to sync
+    if [[ -e /nocow/btrfs-stale/$mp ]]; then
+      echo "$0: error: $mp is stale, mount-latest-subvol first"
+      exit 1
+    fi
+  done
+else
+  # set default mountpoints
+  case $HOSTNAME in
+    # no remote backups atm. note, if we do enable this, configuration below will need some changes.
+    #  frodo)
+    #    prospective_mps=(/i)
+    #    ;;
+    *)
+      prospective_mps=(/a /q)
+      if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
+        prospective_mps+=(/o)
+      fi
+      ;;
+  esac
+  for mp in ${prospective_mps[@]}; do # default mountpoints to sync
+    if [[ -e /nocow/btrfs-stale/$mp ]]; then
+      echo "$0: warning: $mp stale, not adding to default mountpoints"
+      continue
+    fi
+    if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
+      mountpoints+=($mp)
+    fi
+  done
+fi
+
+echo "mountpoints: ${mountpoints[*]}"
 
 ##### end command line parsing ########
 
 rsync-dirs() {
-    local host=$1
-    local path=$2
-    m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
+  local host=$1
+  local path=$2
+  m rsync $dry_run_arg -ahi --relative --delete "$path" "root@$host:/"
 }
 
-vol-conf() {
-    cat >>/etc/btrbk.conf <<EOF
-volume $vol
-EOF
-}
-sub-conf() {
-    cat >>/etc/btrbk.conf <<EOF
-subvolume $sub
-EOF
-}
-tg-conf() {
-    cat >>/etc/btrbk.conf <<EOF
-target send-receive ssh://$tg$vol/btrbk
-EOF
-}
-m() { printf "%s\n" "$*";  "$@"; }
+
+m() { printf "%s: %s\n" "${0##*/}" "$*";  "$@"; }
 
 
 if ! which btrbk &>/dev/null; then
-    echo "$0: error: no btrbk binary found"
+  echo "$0: error: no btrbk binary found"
+  exit 1
 fi
+# if our mountpoints are from stale snapshots,
+# it doesn't make sense to do a backup.
+check-subvol-stale ${mountpoints[@]} || exit 1
 
-if [[ $- == *i* ]]; then
-    progress_arg=--progress
-fi
 
-cat >/etc/btrbk.conf <<'EOF'
-ssh_identity /root/.ssh/id_rsa
+cat >/etc/btrbk.conf <<EOF
+ssh_identity /root/.ssh/home
 # Just a guess that local7 is a good facility to pick.
 # It's a bit odd that the transaction log has to be logged to
 # a file or syslog, while other output is sent to std out.
@@ -92,6 +214,9 @@ ssh_identity /root/.ssh/id_rsa
 # transaction info.
 transaction_syslog local7
 
+# 20%ish speedup[]
+stream_buffer 512m
+
 # so we only run one at a time
 lockfile                   /var/lock/btrbk.lock
 
@@ -100,120 +225,104 @@ timestamp_format long-iso
 
 # only make a snapshot if things have changed
 snapshot_create onchange
-# much less snapshots because I have less space on the
-# local filesystem.
-#snapshot_preserve 2h 2d
-# for now, keeping them equal for simplicity sake
-snapshot_preserve 48h 14d 8w 24m
-snapshot_preserve_min 6h
+# I could make this different from target_preserve,
+# if one disk had less space.
+# for now, keeping them equal.
+snapshot_preserve 36h 14d 8w 24m
+snapshot_preserve_min 4h
 snapshot_dir btrbk
 
 # so, total backups = ~89
-target_preserve 48h 14d 8w 24m
-target_preserve_min 6h
+target_preserve 36h 14d 8w 24m
+target_preserve_min 4h
 
 # if something fails and it's not obvious, try doing
 # btrbk -l debug -v dryrun
-EOF
 
-# note q is owned by root:1000
-# note p is owned 1000:1000 and chmod 700
-mountpoints=(/a)
-qmnt=/q
-if awk '{print $2}' /etc/fstab | grep -xF $qmnt &>/dev/null; then
-    mountpoints+=($qmnt)
-fi
-
-# if our mountpoints are from stale snapshots,
-# it doesn't make sense to do a backup.
-check-subvol-stale ${mountpoints[@]} || exit 1
+rate_limit $rate_limit
+EOF
 
-if [[ ! $targets ]]; then
-    case $HOSTNAME in
-        tp|x2)
-            if ! timeout -s 9 10 ssh frodo :; then
-                targets=($HOME_DOMAIN)
-            fi
-            ;;
-    esac
-    targets=(frodo)
-fi
 
 
-# for i, we just do a 1 way sync from master to backup,
-# and manually manage any changes to that.
-do_i=false
-for tg in ${targets[@]}; do
-    # for an initial run, btrbk requires the dir to exist
-    ssh root@$tg mkdir -p /mnt/root/btrbk
-    if [[ $tg == frodo && $HOSTNAME == treetowl ]]; then
-        do_i=true
-    fi
+for tg in ${targets[@]:-$HOSTNAME}; do
+  # for an initial run, btrbk requires the dir to exist.
+  ssh root@$tg mkdir -p /mnt/root/btrbk
 done
 
 
+
 vol=/mnt/root
-vol-conf
 for m in ${mountpoints[@]}; do
-    sub=${m##*/}
-    sub-conf
+  sub=${m##*/}
+  if [[ $source ]]; then
+    cat >>/etc/btrbk.conf <<EOF
+volume ssh://$source$vol
+subvolume $sub
+target send-receive $vol/btrbk
+EOF
+  else
+    cat >>/etc/btrbk.conf <<EOF
+volume $vol
+subvolume $sub
+EOF
     for tg in ${targets[@]}; do
-        tg-conf
+      cat >>/etc/btrbk.conf <<EOF
+target send-receive ssh://$tg$vol/btrbk
+EOF
     done
+  fi
 done
 
-if $do_i; then
-    vol=/mnt/iroot
-    vol-conf
-    sub=i
-    sub-conf
-    tg=frodo
-    vol=/mnt/root
-    tg-conf
-fi
-
-
 
 # todo: umount first to ensure we don't have any errors
 # todo: do some kill fuser stuff to make umount more reliable
-# todo: run this on a systemd timer on $primary, once per hour,
-# and if primary is, change that timer over to primary, and make
-# sure we mount the latest
-
 
 
 if $conf_only; then
-    exit
+  exit
 fi
 
-if $dry_run; then
-    m btrbk -n $resume_arg run
-else
-    # -q and just using the syslog option seemed nice,
-    # but it doesn't show when a send has a parent and when it doesn't.
-    m btrbk $progress_arg $resume_arg run
-fi
 
-# if we have /p, rsync to targets without /p
-if mountpoint /p >/dev/null; then
+
+if $dry_run; then
+  m btrbk -v -n $cmd_arg
+  exit 0
+elif [[ $cmd_arg == archive ]]; then
+  if [[ $source ]]; then
+    m btrbk $verbose_arg $progress_arg $cmd_arg ssh://$source$vol $vol
+  else
     for tg in ${targets[@]}; do
-        case $tg in
-            tp|li|lk)
-                for x in /p/c/machine_specific/*.hosts; do
-                    if grep -qxF $tg $x; then
-                        dir=${x%.hosts}
-                        rsync-dirs $tg $dir
-                    fi
-                done
-                ;;
-        esac
+      m btrbk $verbose_arg $progress_arg $cmd_arg $vol ssh://$tg$vol
     done
+  fi
+  exit 0
 fi
-
-if ! $dry_run; then
-    m $script_dir/mount-latest-remote ${targets[@]}
+# -q and just using the syslog option seemed nice,
+# but it doesn't show when a send has a parent and when it doesn't.
+m btrbk $verbose_arg $progress_arg $cmd_arg
+
+# if we have it, sync to systems which don't
+if mountpoint $rsync_mountpoint >/dev/null; then
+  for tg in ${targets[@]}; do
+    case $tg in
+      li|lk)
+        for x in /p/c/machine_specific/*.hosts; do
+          if grep -qxF $tg $x; then
+            dir=${x%.hosts}
+            rsync-dirs $tg $dir
+          fi
+        done
+        ;;
+    esac
+  done
 fi
 
+/a/bin/distro-setup/install-my-scripts
+if [[ $source ]]; then
+  m mount-latest-subvol
+else
+  m /a/exe/mount-latest-remote ${targets[@]}
+fi
 
 # todo: move variable data we don't care about backing up
 # to /nocow and symlink it.